package org.kie.kogito.examples;

import org.jbpm.process.core.datatype.impl.type.ObjectDataType;
import org.jbpm.ruleflow.core.RuleFlowProcessFactory;
import org.drools.core.util.KieFunctions;

@javax.enterprise.context.ApplicationScoped()
@javax.inject.Named("demo.helloworld")
public class HelloworldProcess extends org.kie.kogito.process.impl.AbstractProcess<org.kie.kogito.examples.HelloworldModel> {

    @javax.inject.Inject()
    javax.enterprise.inject.Instance<org.kie.api.runtime.process.WorkItemHandler> handlers;

    org.kie.kogito.examples.Application app;

    public HelloworldProcess() {
    }

    @javax.inject.Inject()
    public HelloworldProcess(org.kie.kogito.examples.Application app) {
        super(app.config().process());
        this.app = app;
    }

    public org.kie.kogito.examples.HelloworldProcessInstance createInstance(org.kie.kogito.examples.HelloworldModel value) {
        return new org.kie.kogito.examples.HelloworldProcessInstance(this, value, this.createLegacyProcessRuntime());
    }

    public org.kie.kogito.examples.HelloworldModel createModel() {
        return new org.kie.kogito.examples.HelloworldModel();
    }

    public org.kie.kogito.examples.HelloworldProcessInstance createInstance(org.kie.kogito.Model value) {
        return this.createInstance((org.kie.kogito.examples.HelloworldModel) value);
    }

    public HelloworldProcess configure() {
        super.configure();
        return this;
    }

    protected void registerListeners() {
    }

    public org.kie.api.definition.process.Process legacyProcess() {
        RuleFlowProcessFactory factory = RuleFlowProcessFactory.createProcess("demo.helloworld");
        factory.name("Hello World");
        factory.packageName("org.kie.kogito.examples");
        factory.dynamic(false);
        factory.version("1.0");
        factory.visibility("Public");
        factory.metaData("TargetNamespace", "http://www.omg.org/bpmn20");
        org.jbpm.ruleflow.core.factory.StartNodeFactory startNode1 = factory.startNode(1);
        startNode1.name("Start");
        startNode1.metaData("UniqueId", "start");
        startNode1.metaData("x", 50);
        startNode1.metaData("width", 36);
        startNode1.metaData("y", 57);
        startNode1.metaData("height", 36);
        startNode1.done();
        org.jbpm.ruleflow.core.factory.ActionNodeFactory actionNode2 = factory.actionNode(2);
        actionNode2.name("Script");
        actionNode2.action(kcontext -> {
            System.out.println("Hello World!");;
        });
        actionNode2.metaData("UniqueId", "script");
        actionNode2.metaData("elementname", "Script");
        actionNode2.metaData("NodeType", "ScriptTask");
        actionNode2.metaData("x", 136);
        actionNode2.metaData("width", 110);
        actionNode2.metaData("y", 50);
        actionNode2.metaData("height", 50);
        actionNode2.done();
        org.jbpm.ruleflow.core.factory.EndNodeFactory endNode3 = factory.endNode(3);
        endNode3.name("End");
        endNode3.terminate(false);
        endNode3.metaData("UniqueId", "end");
        endNode3.metaData("x", 296);
        endNode3.metaData("width", 36);
        endNode3.metaData("y", 57);
        endNode3.metaData("height", 36);
        endNode3.done();
        factory.connection(1, 2, "sequenceFlow1");
        factory.connection(2, 3, "sequenceFlow2");
        factory.validate();
        return factory.getProcess();
    }

    public void init(@javax.enterprise.event.Observes() io.quarkus.runtime.StartupEvent event) {
        this.configure();
    }
}
